Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3610)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 3611)
@@ -22,13 +22,19 @@
 ! Current revisions:
 ! ------------------
-! 
+!
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Code update to comply PALM coding rules
+! removed unnecessary informative messsages/location
+! messages and corrected comments on PM units from to kg  
+! bug fix: spcs_name replaced by nvar in DO loops
+!
+! 3591 2018-11-30 17:37:32Z suehring
 ! - Removed salsa dependency.
 ! - Enabled PARAMETRIZED mode for default surfaces when LSM is not applied but 
 !   salsa is (M. Kurppa)
-! 
+!
 ! 3582 2018-11-29 19:16:36Z suehring
 ! resler:
@@ -67,5 +73,5 @@
 ! Authors:
 ! --------
-! @author Emmanuele Russo (Fu-Berlin)
+! @author Emmanuele Russo (FU-Berlin)
 ! @author Sabine Banzhaf  (FU-Berlin)
 ! @author Martijn Schaap  (FU-Berlin, TNO Utrecht)
@@ -79,4 +85,6 @@
 !> @todo revise indices of files read from the netcdf: preproc_emission_data and expert_emission_data
 !> @todo for now emission data may be passed on a singular vertical level: need to be more flexible
+!> @todo fill/activate restart option in chem_emissions_init
+!> @todo discuss dt_emis
 !> @note <Enter notes on the module>
 !> @bug  <Enter known bugs here>
@@ -86,9 +94,9 @@
 
     USE arrays_3d,                                                             &
-       ONLY: rho_air
+        ONLY:  rho_air
 
     USE control_parameters,                                                    &
-       ONLY:  initializing_actions, end_time, message_string,                  &
-              intermediate_timestep_count, dt_3d
+        ONLY:  end_time, message_string, initializing_actions,                 &
+               intermediate_timestep_count, dt_3d
  
     USE indices
@@ -96,148 +104,72 @@
     USE kinds
 
-#if defined ( __netcdf )
-    USE NETCDF
+#if defined( __netcdf )
+    USE netcdf
 #endif
 
     USE netcdf_data_input_mod,                                                  &
-       ONLY: chem_emis_att_type, chem_emis_val_type
+        ONLY: chem_emis_att_type, chem_emis_val_type
 
     USE date_and_time_mod,                                                      &
-       ONLY: time_default_indices, time_preprocessed_indices,                  &
-             month_of_year, day_of_month, hour_of_day,                          &
-             index_mm, index_dd, index_hh
-
+        ONLY: day_of_month, hour_of_day,                                        &
+             index_mm, index_dd, index_hh,                                      &
+             month_of_year, hour_of_day,                                        &
+             time_default_indices, time_preprocessed_indices
+    
     USE chem_gasphase_mod,                                                      &
-       ONLY: spc_names
+        ONLY: spc_names
  
     USE chem_modules
 
     USE statistics,                                                             &   
-           ONLY:  weight_pres
-
+        ONLY:  weight_pres
+
+    
     IMPLICIT NONE
 
+!
 !-- Declare all global variables within the module 
     
-    CHARACTER (LEN=80)                               :: filename_emis                   !> Variable for the name of the netcdf input file
-
-    INTEGER(iwp)                                     :: i                               !> index 1st selected dimension (some dims are not spatial)
-    INTEGER(iwp)                                     :: j                               !> index 2nd selected dimension 
-    INTEGER(iwp)                                     :: i_start                         !> Index to start read variable from netcdf along one dims
-    INTEGER(iwp)                                     :: i_end                           !> Index to end read variable from netcdf in one dims
-    INTEGER(iwp)                                     :: j_start                         !> Index to start read variable from netcdf in additional dims
-    INTEGER(iwp)                                     :: j_end                           !> Index to end read variable from netcdf in additional dims
-    INTEGER(iwp)                                     :: z_start                         !> Index to start read variable from netcdf in additional dims
-    INTEGER(iwp)                                     :: z_end                           !> Index to end read variable from netcdf in additional     dims
-    INTEGER(iwp)                                     :: dt_emis                         !> Time Step Emissions 
-    INTEGER(iwp)                                     :: len_index                       !> length of index (used for several indices)
-    INTEGER(iwp)                                     :: len_index_voc                   !> length of voc index
-    INTEGER(iwp)                                     :: len_index_pm                    !> length of PMs index
-    REAL(wp)                                         :: con_factor                      !> Units Conversion Factor
- 
-
-    ! ---------------------------------------------------------------
-    ! Set Values of molecules, mols, etc
-    ! ---------------------------------------------------------------
-  
-    !> Avogadro number
-    REAL, PARAMETER        ::  Avog = 6.02205e23    ! mlc/mol
- 
-    !> Dobson units:
-    REAL, PARAMETER        ::  Dobs = 2.68668e16    ! (mlc/cm2) / DU
-
-    !> sesalt composition:
-    ! (Seinfeld and Pandis, "Atmospheric Chemistry and Physics",
-    !  table 7.8 "Composition of Sea-Salt", p. 444)
-    REAL, PARAMETER        ::  massfrac_Cl_in_seasalt  = 0.5504       ! (kg Cl )/(kg seasalt)
-    REAL, PARAMETER        ::  massfrac_Na_in_seasalt  = 0.3061       ! (kg Na )/(kg seasalt)
-    REAL, PARAMETER        ::  massfrac_SO4_in_seasalt = 0.0768       ! (kg SO4)/(kg seasalt)
-  
-    !> other numbers 
-    REAL, PARAMETER        ::  xm_seasalt =  74.947e-3                ! kg/mol : NaCl, SO4, ..
-    REAL, PARAMETER        ::  rho_seasalt = 2.2e3                    ! kg/m3
-
-    !> * amonium sulphate
-  
-    REAL, PARAMETER        ::  xm_NH4HSO4  =  xm_NH4 + xm_H + xm_SO4  ! kg/mol
-    REAL, PARAMETER        ::  rho_NH4HSO4a = 1.8e3                   ! kg/m3
-
-    ! ---------------------------------------------------------------
-    ! gas
-    ! ---------------------------------------------------------------
-  
-    !> gas constant                        
-    REAL, PARAMETER        ::  Rgas = 8.3144     ! J/mol/K
-  
-    !> gas constant for dry air
-    REAL, PARAMETER        ::  Rgas_air = Rgas / xm_air   ! J/kg/K
-  
-    !> water vapour
-    REAL, PARAMETER        ::  Rgas_h2o = Rgas / xm_h2o   ! J/kg/K
-  
-    !> standard pressure
-    REAL, PARAMETER        ::  p0 = 1.0e5    ! Pa
-
-    !> sea-level pressure
-    REAL, PARAMETER        ::  p_sealevel = 1.01325e5    ! Pa  <-- suggestion Bram Bregman
-
-    !> global mean pressure
-    REAL, PARAMETER        ::  p_global = 98500.0   ! Pa
-
-    !> specific heat of dry air at constant pressure
-    REAL, PARAMETER        ::  cp_air = 1004.0           ! J/kg/K
-
-    !> Latent heat of evaporation
-    REAL, PARAMETER        ::  lvap = 2.5e6     !  [J kg-1]
-
-    !> Latent heat of condensation at 0 deg Celcius
-    !  (heat (J) necesarry to evaporate 1 kg of water)
-    REAL, PARAMETER        ::  Lc = 22.6e5           ! J/kg
-  
-    !> kappa = R/cp = 2/7
-    REAL, PARAMETER        ::  kappa = 2.0/7.0
-
-    !> Von Karman constant (dry_dep)
-    REAL, PARAMETER        ::  vkarman = 0.4
-
-    !> Boltzmann constant:
-    REAL(wp), PARAMETER     ::  kbolz = 1.38066e-23_wp    ! J/K
-
-    !> Inverse Reference Pressure (1/Pa)    
-    REAL(wp), PARAMETER     ::  pref_i  = 1.0_wp / 100000.0_wp       
- 
-    !>
-    REAL(wp), PARAMETER     ::  r_cp    = 0.286_wp                  !< R / cp (exponent for potential temperature)
+    CHARACTER (LEN=80) ::  filename_emis             !< Variable for the name of the netcdf input file
+
+    INTEGER(iwp) ::  i                               !< index 1st selected dimension (some dims are not spatial)
+    INTEGER(iwp) ::  j                               !< index 2nd selected dimension 
+    INTEGER(iwp) ::  i_start                         !< Index to start read variable from netcdf along one dims
+    INTEGER(iwp) ::  i_end                           !< Index to end read variable from netcdf in one dims
+    INTEGER(iwp) ::  j_start                         !< Index to start read variable from netcdf in additional dims
+    INTEGER(iwp) ::  j_end                           !< Index to end read variable from netcdf in additional dims
+    INTEGER(iwp) ::  z_start                         !< Index to start read variable from netcdf in additional dims
+    INTEGER(iwp) ::  z_end                           !< Index to end read variable from netcdf in additional dims
+    INTEGER(iwp) ::  dt_emis                         !< Time Step Emissions 
+    INTEGER(iwp) ::  len_index                       !< length of index (used for several indices)
+    INTEGER(iwp) ::  len_index_voc                   !< length of voc index
+    INTEGER(iwp) ::  len_index_pm                    !< length of PMs index
+
+    REAL(wp) ::  con_factor                          !< Units Conversion Factor
+                           
+    REAL(wp), PARAMETER ::  Rgas = 8.3144                    !< gas constant in J/mol/K            
+    REAL(wp), PARAMETER ::  pref_i  = 1.0_wp / 100000.0_wp   !< Inverse Reference Pressure (1/Pa) 
+    REAL(wp), PARAMETER ::  r_cp    = 0.286_wp               !< R / cp (exponent for potential temperature)
 
 
     SAVE
 
-!-- Interfaces Part
-
+
+!    
 !-- Checks Input parameters
     INTERFACE chem_emissions_check_parameters
        MODULE PROCEDURE chem_emissions_check_parameters
     END INTERFACE chem_emissions_check_parameters
-
-!-- Reading of NAMELIST parameters
-!    INTERFACE chem_emissions_parin
-!       MODULE PROCEDURE chem_emissions_parin
-!    END INTERFACE chem_emissions_parin
-
-!-- Output of information to the header file
-!    INTERFACE chem_emissions_header
-!       MODULE PROCEDURE chem_emissions_header
-!    END INTERFACE chem_emissions_header
-
+!
 !-- Matching Emissions actions  
     INTERFACE chem_emissions_match
        MODULE PROCEDURE chem_emissions_match
     END INTERFACE chem_emissions_match
-
+!
 !-- Initialization actions  
     INTERFACE chem_emissions_init
        MODULE PROCEDURE chem_emissions_init
     END INTERFACE chem_emissions_init
-
+!
 !-- Setup of Emissions
     INTERFACE chem_emissions_setup
@@ -246,10 +178,9 @@
 
 
-!-- Public Interfaces
-    PUBLIC chem_emissions_init,chem_emissions_match,chem_emissions_setup
-
+    
+    PUBLIC chem_emissions_init, chem_emissions_match, chem_emissions_setup
+!
 !-- Public Variables
-
-    PUBLIC con_factor, len_index,len_index_voc,len_index_pm
+    PUBLIC con_factor, len_index, len_index_pm, len_index_voc
 
  CONTAINS
@@ -263,53 +194,22 @@
 
 
-    !TBD: Where Should we put the call to chem_emissions_check_parameters? In chem_init or in check_parameters?
-
     IMPLICIT NONE
 
-    INTEGER(iwp)           ::  tmp
-
-    TYPE(chem_emis_att_type)   ::  emt
-!
-!--    Call routine for controlling chem_emissions namelist 
-!    CALL chem_emissions_parin
-
-!TBD: In case the given emission values do not coincide with the passed names we should think of a solution: 
-!  I would personally do that if the name of the species differ from the number of emission values, I would 
-!  print a warning that says that in correspondance of that particular species the value is zero. 
-!  An alternative would be to initialize the cs_surface_flux values to a negative number. 
-
-!-- Check Emission Species Number equal to number of passed names for the chemistry species: 
-   IF ( SIZE(emt%species_name) /= emt%nspec  )  THEN
-
-       message_string = 'Numbers of input emission species names and number of species'             //          &
+    INTEGER(iwp) ::  tmp
+
+    TYPE(chem_emis_att_type) ::  emt
+
+    !
+    !-- Check Emission Species Number equal to number of passed names for the chemistry species: 
+    IF ( SIZE(emt%species_name) /= emt%nspec  )  THEN
+
+       message_string = 'Numbers of input emission species names and number of species'     //      &
                          'for which emission values are given do not match'                  
        CALL message( 'chem_emissions_check_parameters', 'CM0437', 2, 2, 0, 6, 0 ) 
-
-
+            
     ENDIF
-
-    !-- Check Emission Species Number equals to number of passed names for the species
-    !IF ( SIZE(emt%species_name) /= SIZE(emt%species_index)  )  THEN
-    !      message_string = 'Number of input emission species names and '             //          &
-    !                       ' number of passed species indices do not match'                  
-    !      CALL message( 'chem_emissions_check_parameters', 'CM0101', 2, 2, 0, 6, 0 ) 
-
-    !ENDIF
-
-    !-- Check Emission Categories
-!    IF ( SIZE(chem_emis%cat_name) /= SIZE(chem_emis%cat_index)  )  THEN
-!       WRITE( message_string, * )                                                        &
-!       'Number of input emission categories name and categories index does not match\\'  
-!       CALL message( 'chem_emissions_check_parameters', 'CM0101', 1, 2, 0, 6, 0 ) 
-!    ENDIF
-
-
-
-    !TBD: Check which other consistency controls should be included
-
-   !TBD: Include check for spatial dimension of netcdf file. If they do not match with the ones 
-   !     of the simulation, the model should print an error.  
-
-END SUBROUTINE chem_emissions_check_parameters
+    
+
+ END SUBROUTINE chem_emissions_check_parameters
 
 !------------------------------------------------------------------------------!
